#include "Driver_PIT.h"

/**
  Function Name	: _PIT0_Init
  Engineer      : Manglio Gonzlez Carrasco
  Date          : 05/01/2011
  
  Parameters	: Nothing
  Returns       : Nothing
  Notes         : This function is used to configure the PIT0 and its interrupt. Currently
                  it is configured at a 4 KHz frequency.
*/
void _PIT0_Init(void)
{
  SIM_SCGC6 |= SIM_SCGC6_PIT_MASK;
  PIT_MCR &= ~PIT_MCR_MDIS_MASK;
  PIT_MCR |= PIT_MCR_FRZ_MASK;
  PIT_LDVAL0 = 12000; // 250uS

  NVICISER2 |= (unsigned long)(84%32);	   
  NVICICPR2 |= (unsigned long)(84%32);

  PIT_TCTRL0 |= PIT_TCTRL_TIE_MASK;
}

/**
  Function Name	: _PIT0_Enable
  Engineer      : Manglio Gonzlez Carrasco
  Date          : 05/01/2011
  
  Parameters	: Nothing
  Returns       : Nothing
  Notes         : This function enables the PIT0.
*/
void _PIT0_Enable(void)
{
  PIT_TCTRL0 |= PIT_TCTRL_TEN_MASK;  
}

/**
  Function Name	: _PIT0_Disable
  Engineer      : Manglio Gonzlez Carrasco
  Date          : 05/01/2011
  
  Parameters	: Nothing
  Returns       : Nothing
  Notes         : This function disables the PIT0.
*/
void _PIT0_Disable(void)
{
  PIT_TCTRL0 &= ~PIT_TCTRL_TEN_MASK;  
}

/*************************************************************************************
  THIS CODE WAS ONLY FOR TESTING PURPOSES. CURRENTLY THE KWIKSTIK DOES NOT USE IT
**************************************************************************************
void _PIT1_Init(void)
{
  PIT_MCR &= ~PIT_MCR_MDIS_MASK;
  PIT_LDVAL1 = 12500; // 250uS
  PIT_TCTRL1 |= PIT_TCTRL_TIE_MASK;
}

void _PIT1_Enable(void)
{
  PIT_TCTRL1 |= PIT_TCTRL_TEN_MASK;  
}

void _PIT1_Disable(void)
{
  PIT_TCTRL1 &= ~PIT_TCTRL_TEN_MASK;  
}

void _PIT2_Init(void)
{
  PIT_MCR &= ~PIT_MCR_MDIS_MASK;
  PIT_LDVAL2 = 12500; // 250uS
  PIT_TCTRL2 |= PIT_TCTRL_TIE_MASK;
}

void _PIT2_Enable(void)
{
  PIT_TCTRL2 |= PIT_TCTRL_TEN_MASK;    
}

void _PIT2_Disable(void)
{
  PIT_TCTRL2 &= ~PIT_TCTRL_TEN_MASK;  
}

void _PIT3_Init(void)
{
  SIM_SCGC6 |= SIM_SCGC6_PIT_MASK;
  PIT_MCR &= ~PIT_MCR_MDIS_MASK;
  PIT_MCR |= PIT_MCR_FRZ_MASK;
  PIT_TFLG3 = 1;
  PIT_LDVAL3 = 12500; // 250uS
  PIT_TCTRL3 |= PIT_TCTRL_TIE_MASK;

  NVICISER2 |= (unsigned long)(87%32);	   
  NVICICPR2 |= (unsigned long)(87%32);
}

void _PIT3_Enable(void)
{
  PIT_TCTRL3 |= PIT_TCTRL_TEN_MASK;    
}

void _PIT3_Disable(void)
{
  PIT_TCTRL3 &= ~PIT_TCTRL_TEN_MASK;  
}

*/