#ifndef _Driver_LCD_Quickstick_h_
#define _Driver_LCD_Quickstick_h_

  #include "PounceTypes_v2.h"
  #include "MK40X256VMD100.h"

  #define CLEAR                       0
  
  #define TOUCHED                     1

  #define ELECTRODE0                  0

  #define ELECTRODE1                  1

  #define ELECTRODE0_TOUCH            0x5000 

  #define ELECTRODE1_TOUCH            0x80

  #define ELECTRODE0_OVER_RUN         0xf000

  #define ELECTRODE1_OVER_RUN         0xf000
  
  #define ELECTRODE0_OVER_RUN_REG     TSI0_THRESHLD0
  
  #define ELECTRODE1_OVER_RUN_REG     TSI0_THRESHLD5
  
  /* Number of scans needed for a touch to remain high to be considered valid */
  #define DBOUNCE_COUNTS              0x00000004

  #define ELECTRODE0_COUNT            (U16)((TSI0_CNTR1) & 0x0000FFFF)

  #define ELECTRODE1_COUNT            (U16)((TSI0_CNTR5 >> 16) & 0x0000FFFF)

  #define ELECTRODE_ENABLE_REG        TSI0_PEN

  #define ELECTRODE0_ENABLE           TSI_PEN_PEN0_MASK

  #define ELECTRODE1_ENABLE           TSI_PEN_PEN5_MASK

  #define START_SCANNING()            TSI0_GENCS |= TSI_GENCS_STM_MASK

  #define ENABLE_EOS_INT()            TSI0_GENCS |= (TSI_GENCS_TSIIE_MASK|TSI_GENCS_ESOR_MASK)

  #define ENABLE_TSI()                TSI0_GENCS |= TSI_GENCS_TSIEN_MASK

  #define DISABLE_TSI()               TSI0_GENCS &= ~TSI_GENCS_TSIEN_MASK

  void _TSIModule_Init(void);
  U08 _TSIModule_Task(void);

#endif