#ifndef _kwikstik_h_
#define _kwikstik_h_
/**HEADER********************************************************************
*
* Copyright (c) 2008 Freescale Semiconductor;
* All Rights Reserved
*
* Copyright (c) 2004-2008 Embedded Access Inc.;
* All Rights Reserved
*
***************************************************************************
*
* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
* THE POSSIBILITY OF SUCH DAMAGE.
*
**************************************************************************
*
* $FileName: kwikstik.h$
* $Version : 3.5.21.0$
* $Date    : May-27-2011$
*
* Comments:
*   The main configuration file
*
*END************************************************************************/

#include <mqx.h>
#include <bsp.h>


//Task numbers
enum {
    MAIN_TASK=1,
    USB_TASK,
    TSI_TASK,
    REMOTE_TASK,
    RECORDER_TASK,
    STATUS_TASK,
    FRETRIS_TASK
};


enum
{
  INIT = 0,
  MAIN,
  ELECTRODE_CHECK,
  SOUND_RECORDER,
  REMOTE_CONTROLLER,
  USB_MOUSE,
  FRETRIS
};

extern unsigned char MainMenuStateMachine;

#define MENU_OPTIONS        3

/* Prototype for Tasks */
extern void Main_Task(uint_32 data);
extern void USB_Task(uint_32 data);
extern void TSI_Task(uint_32 data);
extern void _RemoteControl_Task(uint_32 data);
extern void _SoundRecorder_Task(uint_32 data);
extern void Status_Task(uint_32 data);
extern void F_Task(uint_32 data);

#endif
